<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>19.2. json — JSON encoder and decoder &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="19. Internet Data Handling" href="netdata.html" />
    <link rel="next" title="19.3. mailcap — Mailcap file handling" href="mailcap.html" />
    <link rel="prev" title="19.1.14. email: Examples" href="email-examples.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="mailcap.html" title="19.3. mailcap — Mailcap file handling"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="email-examples.html" title="19.1.14. email: Examples"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="netdata.html" accesskey="U">19. Internet Data Handling</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-json">
<span id="json-json-encoder-and-decoder"></span><h1>19.2. <a class="reference internal" href="#module-json" title="json: Encode and decode the JSON format."><code class="xref py py-mod docutils literal"><span class="pre">json</span></code></a> &#8212; JSON encoder and decoder<a class="headerlink" href="#module-json" title="Permalink to this headline">¶</a></h1>
<p><a class="reference external" href="http://json.org">JSON (JavaScript Object Notation)</a>, specified by
<span class="target" id="index-0"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7159.html"><strong>RFC 7159</strong></a> (which obsoletes <span class="target" id="index-1"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4627.html"><strong>RFC 4627</strong></a>) and by
<a class="reference external" href="http://www.ecma-international.org/publications/standards/Ecma-404.htm">ECMA-404</a>,
is a lightweight data interchange format inspired by
<a class="reference external" href="http://en.wikipedia.org/wiki/JavaScript">JavaScript</a> object literal syntax
(although it is not a strict subset of JavaScript <a class="footnote-reference" href="#rfc-errata" id="id1">[1]</a> ).</p>
<p><a class="reference internal" href="#module-json" title="json: Encode and decode the JSON format."><code class="xref py py-mod docutils literal"><span class="pre">json</span></code></a> exposes an API familiar to users of the standard library
<a class="reference internal" href="marshal.html#module-marshal" title="marshal: Convert Python objects to streams of bytes and back (with different constraints)."><code class="xref py py-mod docutils literal"><span class="pre">marshal</span></code></a> and <a class="reference internal" href="pickle.html#module-pickle" title="pickle: Convert Python objects to streams of bytes and back."><code class="xref py py-mod docutils literal"><span class="pre">pickle</span></code></a> modules.</p>
<p>Encoding basic Python object hierarchies:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">json</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">([</span><span class="s">&#39;foo&#39;</span><span class="p">,</span> <span class="p">{</span><span class="s">&#39;bar&#39;</span><span class="p">:</span> <span class="p">(</span><span class="s">&#39;baz&#39;</span><span class="p">,</span> <span class="k">None</span><span class="p">,</span> <span class="mf">1.0</span><span class="p">,</span> <span class="mi">2</span><span class="p">)}])</span>
<span class="go">&#39;[&quot;foo&quot;, {&quot;bar&quot;: [&quot;baz&quot;, null, 1.0, 2]}]&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">(</span><span class="s">&quot;</span><span class="se">\&quot;</span><span class="s">foo</span><span class="se">\b</span><span class="s">ar&quot;</span><span class="p">))</span>
<span class="go">&quot;\&quot;foo\bar&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">(</span><span class="s">&#39;</span><span class="se">\u1234</span><span class="s">&#39;</span><span class="p">))</span>
<span class="go">&quot;\u1234&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">(</span><span class="s">&#39;</span><span class="se">\\</span><span class="s">&#39;</span><span class="p">))</span>
<span class="go">&quot;\\&quot;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">({</span><span class="s">&quot;c&quot;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span> <span class="s">&quot;b&quot;</span><span class="p">:</span> <span class="mi">0</span><span class="p">,</span> <span class="s">&quot;a&quot;</span><span class="p">:</span> <span class="mi">0</span><span class="p">},</span> <span class="n">sort_keys</span><span class="o">=</span><span class="k">True</span><span class="p">))</span>
<span class="go">{&quot;a&quot;: 0, &quot;b&quot;: 0, &quot;c&quot;: 0}</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">io</span> <span class="k">import</span> <span class="n">StringIO</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">io</span> <span class="o">=</span> <span class="n">StringIO</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">dump</span><span class="p">([</span><span class="s">&#39;streaming API&#39;</span><span class="p">],</span> <span class="n">io</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">io</span><span class="o">.</span><span class="n">getvalue</span><span class="p">()</span>
<span class="go">&#39;[&quot;streaming API&quot;]&#39;</span>
</pre></div>
</div>
<p>Compact encoding:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">json</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">([</span><span class="mi">1</span><span class="p">,</span><span class="mi">2</span><span class="p">,</span><span class="mi">3</span><span class="p">,{</span><span class="s">&#39;4&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">,</span> <span class="s">&#39;6&#39;</span><span class="p">:</span> <span class="mi">7</span><span class="p">}],</span> <span class="n">separators</span><span class="o">=</span><span class="p">(</span><span class="s">&#39;,&#39;</span><span class="p">,</span> <span class="s">&#39;:&#39;</span><span class="p">))</span>
<span class="go">&#39;[1,2,3,{&quot;4&quot;:5,&quot;6&quot;:7}]&#39;</span>
</pre></div>
</div>
<p>Pretty printing:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">json</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">print</span><span class="p">(</span><span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">({</span><span class="s">&#39;4&#39;</span><span class="p">:</span> <span class="mi">5</span><span class="p">,</span> <span class="s">&#39;6&#39;</span><span class="p">:</span> <span class="mi">7</span><span class="p">},</span> <span class="n">sort_keys</span><span class="o">=</span><span class="k">True</span><span class="p">,</span> <span class="n">indent</span><span class="o">=</span><span class="mi">4</span><span class="p">))</span>
<span class="go">{</span>
<span class="go">    &quot;4&quot;: 5,</span>
<span class="go">    &quot;6&quot;: 7</span>
<span class="go">}</span>
</pre></div>
</div>
<p>Decoding JSON:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">json</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="s">&#39;[&quot;foo&quot;, {&quot;bar&quot;:[&quot;baz&quot;, null, 1.0, 2]}]&#39;</span><span class="p">)</span>
<span class="go">[&#39;foo&#39;, {&#39;bar&#39;: [&#39;baz&#39;, None, 1.0, 2]}]</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="s">&#39;&quot;</span><span class="se">\\</span><span class="s">&quot;foo</span><span class="se">\\</span><span class="s">bar&quot;&#39;</span><span class="p">)</span>
<span class="go">&#39;&quot;foo\x08ar&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">io</span> <span class="k">import</span> <span class="n">StringIO</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">io</span> <span class="o">=</span> <span class="n">StringIO</span><span class="p">(</span><span class="s">&#39;[&quot;streaming API&quot;]&#39;</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">io</span><span class="p">)</span>
<span class="go">[&#39;streaming API&#39;]</span>
</pre></div>
</div>
<p>Specializing JSON object decoding:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">json</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">def</span> <span class="nf">as_complex</span><span class="p">(</span><span class="n">dct</span><span class="p">):</span>
<span class="gp">... </span>    <span class="k">if</span> <span class="s">&#39;__complex__&#39;</span> <span class="ow">in</span> <span class="n">dct</span><span class="p">:</span>
<span class="gp">... </span>        <span class="k">return</span> <span class="nb">complex</span><span class="p">(</span><span class="n">dct</span><span class="p">[</span><span class="s">&#39;real&#39;</span><span class="p">],</span> <span class="n">dct</span><span class="p">[</span><span class="s">&#39;imag&#39;</span><span class="p">])</span>
<span class="gp">... </span>    <span class="k">return</span> <span class="n">dct</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="s">&#39;{&quot;__complex__&quot;: true, &quot;real&quot;: 1, &quot;imag&quot;: 2}&#39;</span><span class="p">,</span>
<span class="gp">... </span>    <span class="n">object_hook</span><span class="o">=</span><span class="n">as_complex</span><span class="p">)</span>
<span class="go">(1+2j)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">decimal</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="s">&#39;1.1&#39;</span><span class="p">,</span> <span class="n">parse_float</span><span class="o">=</span><span class="n">decimal</span><span class="o">.</span><span class="n">Decimal</span><span class="p">)</span>
<span class="go">Decimal(&#39;1.1&#39;)</span>
</pre></div>
</div>
<p>Extending <a class="reference internal" href="#json.JSONEncoder" title="json.JSONEncoder"><code class="xref py py-class docutils literal"><span class="pre">JSONEncoder</span></code></a>:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">json</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">class</span> <span class="nc">ComplexEncoder</span><span class="p">(</span><span class="n">json</span><span class="o">.</span><span class="n">JSONEncoder</span><span class="p">):</span>
<span class="gp">... </span>    <span class="k">def</span> <span class="nf">default</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">obj</span><span class="p">):</span>
<span class="gp">... </span>        <span class="k">if</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">obj</span><span class="p">,</span> <span class="nb">complex</span><span class="p">):</span>
<span class="gp">... </span>            <span class="k">return</span> <span class="p">[</span><span class="n">obj</span><span class="o">.</span><span class="n">real</span><span class="p">,</span> <span class="n">obj</span><span class="o">.</span><span class="n">imag</span><span class="p">]</span>
<span class="gp">... </span>        <span class="c"># Let the base class default method raise the TypeError</span>
<span class="gp">... </span>        <span class="k">return</span> <span class="n">json</span><span class="o">.</span><span class="n">JSONEncoder</span><span class="o">.</span><span class="n">default</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">obj</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">(</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">1</span><span class="n">j</span><span class="p">,</span> <span class="n">cls</span><span class="o">=</span><span class="n">ComplexEncoder</span><span class="p">)</span>
<span class="go">&#39;[2.0, 1.0]&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">ComplexEncoder</span><span class="p">()</span><span class="o">.</span><span class="n">encode</span><span class="p">(</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">1</span><span class="n">j</span><span class="p">)</span>
<span class="go">&#39;[2.0, 1.0]&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="nb">list</span><span class="p">(</span><span class="n">ComplexEncoder</span><span class="p">()</span><span class="o">.</span><span class="n">iterencode</span><span class="p">(</span><span class="mi">2</span> <span class="o">+</span> <span class="mi">1</span><span class="n">j</span><span class="p">))</span>
<span class="go">[&#39;[2.0&#39;, &#39;, 1.0&#39;, &#39;]&#39;]</span>
</pre></div>
</div>
<p>Using json.tool from the shell to validate and pretty-print:</p>
<div class="highlight-bash"><div class="highlight"><pre><span class="nv">$ </span><span class="nb">echo</span> <span class="s1">&#39;{&quot;json&quot;:&quot;obj&quot;}&#39;</span> <span class="p">|</span> python -m json.tool
<span class="o">{</span>
    <span class="s2">&quot;json&quot;</span>: <span class="s2">&quot;obj&quot;</span>
<span class="o">}</span>
<span class="nv">$ </span><span class="nb">echo</span> <span class="s1">&#39;{1.2:3.4}&#39;</span> <span class="p">|</span> python -m json.tool
Expecting property name enclosed in double quotes: line <span class="m">1</span> column <span class="m">2</span> <span class="o">(</span>char 1<span class="o">)</span>
</pre></div>
</div>
<p>See <a class="reference internal" href="#json-commandline"><span>Command Line Interface</span></a> for detailed documentation.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">JSON is a subset of <a class="reference external" href="http://yaml.org/">YAML</a> 1.2.  The JSON produced by
this module&#8217;s default settings (in particular, the default <em>separators</em>
value) is also a subset of YAML 1.0 and 1.1.  This module can thus also be
used as a YAML serializer.</p>
</div>
<div class="section" id="basic-usage">
<h2>19.2.1. Basic Usage<a class="headerlink" href="#basic-usage" title="Permalink to this headline">¶</a></h2>
<dl class="function">
<dt id="json.dump">
<code class="descclassname">json.</code><code class="descname">dump</code><span class="sig-paren">(</span><em>obj</em>, <em>fp</em>, <em>skipkeys=False</em>, <em>ensure_ascii=True</em>, <em>check_circular=True</em>, <em>allow_nan=True</em>, <em>cls=None</em>, <em>indent=None</em>, <em>separators=None</em>, <em>default=None</em>, <em>sort_keys=False</em>, <em>**kw</em><span class="sig-paren">)</span><a class="headerlink" href="#json.dump" title="Permalink to this definition">¶</a></dt>
<dd><p>Serialize <em>obj</em> as a JSON formatted stream to <em>fp</em> (a <code class="docutils literal"><span class="pre">.write()</span></code>-supporting
<a class="reference internal" href="../glossary.html#term-file-like-object"><span class="xref std std-term">file-like object</span></a>) using this <a class="reference internal" href="#py-to-json-table"><span>conversion table</span></a>.</p>
<p>If <em>skipkeys</em> is <code class="docutils literal"><span class="pre">True</span></code> (default: <code class="docutils literal"><span class="pre">False</span></code>), then dict keys that are not
of a basic type (<a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">str</span></code></a>, <a class="reference internal" href="functions.html#int" title="int"><code class="xref py py-class docutils literal"><span class="pre">int</span></code></a>, <a class="reference internal" href="functions.html#float" title="float"><code class="xref py py-class docutils literal"><span class="pre">float</span></code></a>, <a class="reference internal" href="functions.html#bool" title="bool"><code class="xref py py-class docutils literal"><span class="pre">bool</span></code></a>,
<code class="docutils literal"><span class="pre">None</span></code>) will be skipped instead of raising a <a class="reference internal" href="exceptions.html#TypeError" title="TypeError"><code class="xref py py-exc docutils literal"><span class="pre">TypeError</span></code></a>.</p>
<p>The <a class="reference internal" href="#module-json" title="json: Encode and decode the JSON format."><code class="xref py py-mod docutils literal"><span class="pre">json</span></code></a> module always produces <a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">str</span></code></a> objects, not
<a class="reference internal" href="functions.html#bytes" title="bytes"><code class="xref py py-class docutils literal"><span class="pre">bytes</span></code></a> objects. Therefore, <code class="docutils literal"><span class="pre">fp.write()</span></code> must support <a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">str</span></code></a>
input.</p>
<p>If <em>ensure_ascii</em> is <code class="docutils literal"><span class="pre">True</span></code> (the default), the output is guaranteed to
have all incoming non-ASCII characters escaped.  If <em>ensure_ascii</em> is
<code class="docutils literal"><span class="pre">False</span></code>, these characters will be output as-is.</p>
<p>If <em>check_circular</em> is <code class="docutils literal"><span class="pre">False</span></code> (default: <code class="docutils literal"><span class="pre">True</span></code>), then the circular
reference check for container types will be skipped and a circular reference
will result in an <a class="reference internal" href="exceptions.html#OverflowError" title="OverflowError"><code class="xref py py-exc docutils literal"><span class="pre">OverflowError</span></code></a> (or worse).</p>
<p>If <em>allow_nan</em> is <code class="docutils literal"><span class="pre">False</span></code> (default: <code class="docutils literal"><span class="pre">True</span></code>), then it will be a
<a class="reference internal" href="exceptions.html#ValueError" title="ValueError"><code class="xref py py-exc docutils literal"><span class="pre">ValueError</span></code></a> to serialize out of range <a class="reference internal" href="functions.html#float" title="float"><code class="xref py py-class docutils literal"><span class="pre">float</span></code></a> values (<code class="docutils literal"><span class="pre">nan</span></code>,
<code class="docutils literal"><span class="pre">inf</span></code>, <code class="docutils literal"><span class="pre">-inf</span></code>) in strict compliance of the JSON specification, instead of
using the JavaScript equivalents (<code class="docutils literal"><span class="pre">NaN</span></code>, <code class="docutils literal"><span class="pre">Infinity</span></code>, <code class="docutils literal"><span class="pre">-Infinity</span></code>).</p>
<p>If <em>indent</em> is a non-negative integer or string, then JSON array elements and
object members will be pretty-printed with that indent level.  An indent level
of 0, negative, or <code class="docutils literal"><span class="pre">&quot;&quot;</span></code> will only insert newlines.  <code class="docutils literal"><span class="pre">None</span></code> (the default)
selects the most compact representation. Using a positive integer indent
indents that many spaces per level.  If <em>indent</em> is a string (such as <code class="docutils literal"><span class="pre">&quot;\t&quot;</span></code>),
that string is used to indent each level.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span>Allow strings for <em>indent</em> in addition to integers.</p>
</div>
<p>If specified, <em>separators</em> should be an <code class="docutils literal"><span class="pre">(item_separator,</span> <span class="pre">key_separator)</span></code>
tuple.  The default is <code class="docutils literal"><span class="pre">(',</span> <span class="pre">',</span> <span class="pre">':</span> <span class="pre">')</span></code> if <em>indent</em> is <code class="docutils literal"><span class="pre">None</span></code> and
<code class="docutils literal"><span class="pre">(',',</span> <span class="pre">':</span> <span class="pre">')</span></code> otherwise.  To get the most compact JSON representation,
you should specify <code class="docutils literal"><span class="pre">(',',</span> <span class="pre">':')</span></code> to eliminate whitespace.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>Use <code class="docutils literal"><span class="pre">(',',</span> <span class="pre">':</span> <span class="pre">')</span></code> as default if <em>indent</em> is not <code class="docutils literal"><span class="pre">None</span></code>.</p>
</div>
<p><em>default(obj)</em> is a function that should return a serializable version of
<em>obj</em> or raise <a class="reference internal" href="exceptions.html#TypeError" title="TypeError"><code class="xref py py-exc docutils literal"><span class="pre">TypeError</span></code></a>.  The default simply raises <a class="reference internal" href="exceptions.html#TypeError" title="TypeError"><code class="xref py py-exc docutils literal"><span class="pre">TypeError</span></code></a>.</p>
<p>If <em>sort_keys</em> is <code class="docutils literal"><span class="pre">True</span></code> (default: <code class="docutils literal"><span class="pre">False</span></code>), then the output of
dictionaries will be sorted by key.</p>
<p>To use a custom <a class="reference internal" href="#json.JSONEncoder" title="json.JSONEncoder"><code class="xref py py-class docutils literal"><span class="pre">JSONEncoder</span></code></a> subclass (e.g. one that overrides the
<code class="xref py py-meth docutils literal"><span class="pre">default()</span></code> method to serialize additional types), specify it with the
<em>cls</em> kwarg; otherwise <a class="reference internal" href="#json.JSONEncoder" title="json.JSONEncoder"><code class="xref py py-class docutils literal"><span class="pre">JSONEncoder</span></code></a> is used.</p>
</dd></dl>

<dl class="function">
<dt id="json.dumps">
<code class="descclassname">json.</code><code class="descname">dumps</code><span class="sig-paren">(</span><em>obj</em>, <em>skipkeys=False</em>, <em>ensure_ascii=True</em>, <em>check_circular=True</em>, <em>allow_nan=True</em>, <em>cls=None</em>, <em>indent=None</em>, <em>separators=None</em>, <em>default=None</em>, <em>sort_keys=False</em>, <em>**kw</em><span class="sig-paren">)</span><a class="headerlink" href="#json.dumps" title="Permalink to this definition">¶</a></dt>
<dd><p>Serialize <em>obj</em> to a JSON formatted <a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">str</span></code></a> using this <a class="reference internal" href="#py-to-json-table"><span>conversion
table</span></a>.  The arguments have the same meaning as in
<a class="reference internal" href="#json.dump" title="json.dump"><code class="xref py py-func docutils literal"><span class="pre">dump()</span></code></a>.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Unlike <a class="reference internal" href="pickle.html#module-pickle" title="pickle: Convert Python objects to streams of bytes and back."><code class="xref py py-mod docutils literal"><span class="pre">pickle</span></code></a> and <a class="reference internal" href="marshal.html#module-marshal" title="marshal: Convert Python objects to streams of bytes and back (with different constraints)."><code class="xref py py-mod docutils literal"><span class="pre">marshal</span></code></a>, JSON is not a framed protocol,
so trying to serialize multiple objects with repeated calls to
<a class="reference internal" href="#json.dump" title="json.dump"><code class="xref py py-func docutils literal"><span class="pre">dump()</span></code></a> using the same <em>fp</em> will result in an invalid JSON file.</p>
</div>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">Keys in key/value pairs of JSON are always of the type <a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">str</span></code></a>. When
a dictionary is converted into JSON, all the keys of the dictionary are
coerced to strings. As a result of this, if a dictionary is converted
into JSON and then back into a dictionary, the dictionary may not equal
the original one. That is, <code class="docutils literal"><span class="pre">loads(dumps(x))</span> <span class="pre">!=</span> <span class="pre">x</span></code> if x has non-string
keys.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="json.load">
<code class="descclassname">json.</code><code class="descname">load</code><span class="sig-paren">(</span><em>fp</em>, <em>cls=None</em>, <em>object_hook=None</em>, <em>parse_float=None</em>, <em>parse_int=None</em>, <em>parse_constant=None</em>, <em>object_pairs_hook=None</em>, <em>**kw</em><span class="sig-paren">)</span><a class="headerlink" href="#json.load" title="Permalink to this definition">¶</a></dt>
<dd><p>Deserialize <em>fp</em> (a <code class="docutils literal"><span class="pre">.read()</span></code>-supporting <a class="reference internal" href="../glossary.html#term-file-like-object"><span class="xref std std-term">file-like object</span></a>
containing a JSON document) to a Python object using this <a class="reference internal" href="#json-to-py-table"><span>conversion
table</span></a>.</p>
<p><em>object_hook</em> is an optional function that will be called with the result of
any object literal decoded (a <a class="reference internal" href="stdtypes.html#dict" title="dict"><code class="xref py py-class docutils literal"><span class="pre">dict</span></code></a>).  The return value of
<em>object_hook</em> will be used instead of the <a class="reference internal" href="stdtypes.html#dict" title="dict"><code class="xref py py-class docutils literal"><span class="pre">dict</span></code></a>.  This feature can be used
to implement custom decoders (e.g. <a class="reference external" href="http://www.jsonrpc.org">JSON-RPC</a>
class hinting).</p>
<p><em>object_pairs_hook</em> is an optional function that will be called with the
result of any object literal decoded with an ordered list of pairs.  The
return value of <em>object_pairs_hook</em> will be used instead of the
<a class="reference internal" href="stdtypes.html#dict" title="dict"><code class="xref py py-class docutils literal"><span class="pre">dict</span></code></a>.  This feature can be used to implement custom decoders that
rely on the order that the key and value pairs are decoded (for example,
<a class="reference internal" href="collections.html#collections.OrderedDict" title="collections.OrderedDict"><code class="xref py py-func docutils literal"><span class="pre">collections.OrderedDict()</span></code></a> will remember the order of insertion). If
<em>object_hook</em> is also defined, the <em>object_pairs_hook</em> takes priority.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.1: </span>Added support for <em>object_pairs_hook</em>.</p>
</div>
<p><em>parse_float</em>, if specified, will be called with the string of every JSON
float to be decoded.  By default, this is equivalent to <code class="docutils literal"><span class="pre">float(num_str)</span></code>.
This can be used to use another datatype or parser for JSON floats
(e.g. <a class="reference internal" href="decimal.html#decimal.Decimal" title="decimal.Decimal"><code class="xref py py-class docutils literal"><span class="pre">decimal.Decimal</span></code></a>).</p>
<p><em>parse_int</em>, if specified, will be called with the string of every JSON int
to be decoded.  By default, this is equivalent to <code class="docutils literal"><span class="pre">int(num_str)</span></code>.  This can
be used to use another datatype or parser for JSON integers
(e.g. <a class="reference internal" href="functions.html#float" title="float"><code class="xref py py-class docutils literal"><span class="pre">float</span></code></a>).</p>
<p><em>parse_constant</em>, if specified, will be called with one of the following
strings: <code class="docutils literal"><span class="pre">'-Infinity'</span></code>, <code class="docutils literal"><span class="pre">'Infinity'</span></code>, <code class="docutils literal"><span class="pre">'NaN'</span></code>.
This can be used to raise an exception if invalid JSON numbers
are encountered.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.1: </span><em>parse_constant</em> doesn&#8217;t get called on &#8216;null&#8217;, &#8216;true&#8217;, &#8216;false&#8217; anymore.</p>
</div>
<p>To use a custom <a class="reference internal" href="#json.JSONDecoder" title="json.JSONDecoder"><code class="xref py py-class docutils literal"><span class="pre">JSONDecoder</span></code></a> subclass, specify it with the <code class="docutils literal"><span class="pre">cls</span></code>
kwarg; otherwise <a class="reference internal" href="#json.JSONDecoder" title="json.JSONDecoder"><code class="xref py py-class docutils literal"><span class="pre">JSONDecoder</span></code></a> is used.  Additional keyword arguments
will be passed to the constructor of the class.</p>
<p>If the data being deserialized is not a valid JSON document, a
<a class="reference internal" href="#json.JSONDecodeError" title="json.JSONDecodeError"><code class="xref py py-exc docutils literal"><span class="pre">JSONDecodeError</span></code></a> will be raised.</p>
</dd></dl>

<dl class="function">
<dt id="json.loads">
<code class="descclassname">json.</code><code class="descname">loads</code><span class="sig-paren">(</span><em>s</em>, <em>encoding=None</em>, <em>cls=None</em>, <em>object_hook=None</em>, <em>parse_float=None</em>, <em>parse_int=None</em>, <em>parse_constant=None</em>, <em>object_pairs_hook=None</em>, <em>**kw</em><span class="sig-paren">)</span><a class="headerlink" href="#json.loads" title="Permalink to this definition">¶</a></dt>
<dd><p>Deserialize <em>s</em> (a <a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">str</span></code></a> instance containing a JSON document) to a
Python object using this <a class="reference internal" href="#json-to-py-table"><span>conversion table</span></a>.</p>
<p>The other arguments have the same meaning as in <a class="reference internal" href="#json.load" title="json.load"><code class="xref py py-func docutils literal"><span class="pre">load()</span></code></a>, except
<em>encoding</em> which is ignored and deprecated.</p>
<p>If the data being deserialized is not a valid JSON document, a
<a class="reference internal" href="#json.JSONDecodeError" title="json.JSONDecodeError"><code class="xref py py-exc docutils literal"><span class="pre">JSONDecodeError</span></code></a> will be raised.</p>
</dd></dl>

</div>
<div class="section" id="encoders-and-decoders">
<h2>19.2.2. Encoders and Decoders<a class="headerlink" href="#encoders-and-decoders" title="Permalink to this headline">¶</a></h2>
<dl class="class">
<dt id="json.JSONDecoder">
<em class="property">class </em><code class="descclassname">json.</code><code class="descname">JSONDecoder</code><span class="sig-paren">(</span><em>object_hook=None</em>, <em>parse_float=None</em>, <em>parse_int=None</em>, <em>parse_constant=None</em>, <em>strict=True</em>, <em>object_pairs_hook=None</em><span class="sig-paren">)</span><a class="headerlink" href="#json.JSONDecoder" title="Permalink to this definition">¶</a></dt>
<dd><p>Simple JSON decoder.</p>
<p>Performs the following translations in decoding by default:</p>
<table border="1" class="docutils" id="json-to-py-table">
<colgroup>
<col width="44%" />
<col width="56%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">JSON</th>
<th class="head">Python</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>object</td>
<td>dict</td>
</tr>
<tr class="row-odd"><td>array</td>
<td>list</td>
</tr>
<tr class="row-even"><td>string</td>
<td>str</td>
</tr>
<tr class="row-odd"><td>number (int)</td>
<td>int</td>
</tr>
<tr class="row-even"><td>number (real)</td>
<td>float</td>
</tr>
<tr class="row-odd"><td>true</td>
<td>True</td>
</tr>
<tr class="row-even"><td>false</td>
<td>False</td>
</tr>
<tr class="row-odd"><td>null</td>
<td>None</td>
</tr>
</tbody>
</table>
<p>It also understands <code class="docutils literal"><span class="pre">NaN</span></code>, <code class="docutils literal"><span class="pre">Infinity</span></code>, and <code class="docutils literal"><span class="pre">-Infinity</span></code> as their
corresponding <code class="docutils literal"><span class="pre">float</span></code> values, which is outside the JSON spec.</p>
<p><em>object_hook</em>, if specified, will be called with the result of every JSON
object decoded and its return value will be used in place of the given
<a class="reference internal" href="stdtypes.html#dict" title="dict"><code class="xref py py-class docutils literal"><span class="pre">dict</span></code></a>.  This can be used to provide custom deserializations (e.g. to
support JSON-RPC class hinting).</p>
<p><em>object_pairs_hook</em>, if specified will be called with the result of every
JSON object decoded with an ordered list of pairs.  The return value of
<em>object_pairs_hook</em> will be used instead of the <a class="reference internal" href="stdtypes.html#dict" title="dict"><code class="xref py py-class docutils literal"><span class="pre">dict</span></code></a>.  This
feature can be used to implement custom decoders that rely on the order
that the key and value pairs are decoded (for example,
<a class="reference internal" href="collections.html#collections.OrderedDict" title="collections.OrderedDict"><code class="xref py py-func docutils literal"><span class="pre">collections.OrderedDict()</span></code></a> will remember the order of insertion). If
<em>object_hook</em> is also defined, the <em>object_pairs_hook</em> takes priority.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.1: </span>Added support for <em>object_pairs_hook</em>.</p>
</div>
<p><em>parse_float</em>, if specified, will be called with the string of every JSON
float to be decoded.  By default, this is equivalent to <code class="docutils literal"><span class="pre">float(num_str)</span></code>.
This can be used to use another datatype or parser for JSON floats
(e.g. <a class="reference internal" href="decimal.html#decimal.Decimal" title="decimal.Decimal"><code class="xref py py-class docutils literal"><span class="pre">decimal.Decimal</span></code></a>).</p>
<p><em>parse_int</em>, if specified, will be called with the string of every JSON int
to be decoded.  By default, this is equivalent to <code class="docutils literal"><span class="pre">int(num_str)</span></code>.  This can
be used to use another datatype or parser for JSON integers
(e.g. <a class="reference internal" href="functions.html#float" title="float"><code class="xref py py-class docutils literal"><span class="pre">float</span></code></a>).</p>
<p><em>parse_constant</em>, if specified, will be called with one of the following
strings: <code class="docutils literal"><span class="pre">'-Infinity'</span></code>, <code class="docutils literal"><span class="pre">'Infinity'</span></code>, <code class="docutils literal"><span class="pre">'NaN'</span></code>, <code class="docutils literal"><span class="pre">'null'</span></code>, <code class="docutils literal"><span class="pre">'true'</span></code>,
<code class="docutils literal"><span class="pre">'false'</span></code>.  This can be used to raise an exception if invalid JSON numbers
are encountered.</p>
<p>If <em>strict</em> is <code class="docutils literal"><span class="pre">False</span></code> (<code class="docutils literal"><span class="pre">True</span></code> is the default), then control characters
will be allowed inside strings.  Control characters in this context are
those with character codes in the 0-31 range, including <code class="docutils literal"><span class="pre">'\t'</span></code> (tab),
<code class="docutils literal"><span class="pre">'\n'</span></code>, <code class="docutils literal"><span class="pre">'\r'</span></code> and <code class="docutils literal"><span class="pre">'\0'</span></code>.</p>
<p>If the data being deserialized is not a valid JSON document, a
<a class="reference internal" href="#json.JSONDecodeError" title="json.JSONDecodeError"><code class="xref py py-exc docutils literal"><span class="pre">JSONDecodeError</span></code></a> will be raised.</p>
<dl class="method">
<dt id="json.JSONDecoder.decode">
<code class="descname">decode</code><span class="sig-paren">(</span><em>s</em><span class="sig-paren">)</span><a class="headerlink" href="#json.JSONDecoder.decode" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the Python representation of <em>s</em> (a <a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">str</span></code></a> instance
containing a JSON document).</p>
<p><a class="reference internal" href="#json.JSONDecodeError" title="json.JSONDecodeError"><code class="xref py py-exc docutils literal"><span class="pre">JSONDecodeError</span></code></a> will be raised if the given JSON document is not
valid.</p>
</dd></dl>

<dl class="method">
<dt id="json.JSONDecoder.raw_decode">
<code class="descname">raw_decode</code><span class="sig-paren">(</span><em>s</em><span class="sig-paren">)</span><a class="headerlink" href="#json.JSONDecoder.raw_decode" title="Permalink to this definition">¶</a></dt>
<dd><p>Decode a JSON document from <em>s</em> (a <a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">str</span></code></a> beginning with a
JSON document) and return a 2-tuple of the Python representation
and the index in <em>s</em> where the document ended.</p>
<p>This can be used to decode a JSON document from a string that may have
extraneous data at the end.</p>
</dd></dl>

</dd></dl>

<dl class="class">
<dt id="json.JSONEncoder">
<em class="property">class </em><code class="descclassname">json.</code><code class="descname">JSONEncoder</code><span class="sig-paren">(</span><em>skipkeys=False</em>, <em>ensure_ascii=True</em>, <em>check_circular=True</em>, <em>allow_nan=True</em>, <em>sort_keys=False</em>, <em>indent=None</em>, <em>separators=None</em>, <em>default=None</em><span class="sig-paren">)</span><a class="headerlink" href="#json.JSONEncoder" title="Permalink to this definition">¶</a></dt>
<dd><p>Extensible JSON encoder for Python data structures.</p>
<p>Supports the following objects and types by default:</p>
<table border="1" class="docutils" id="py-to-json-table">
<colgroup>
<col width="73%" />
<col width="27%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Python</th>
<th class="head">JSON</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>dict</td>
<td>object</td>
</tr>
<tr class="row-odd"><td>list, tuple</td>
<td>array</td>
</tr>
<tr class="row-even"><td>str</td>
<td>string</td>
</tr>
<tr class="row-odd"><td>int, float, int- &amp; float-derived Enums</td>
<td>number</td>
</tr>
<tr class="row-even"><td>True</td>
<td>true</td>
</tr>
<tr class="row-odd"><td>False</td>
<td>false</td>
</tr>
<tr class="row-even"><td>None</td>
<td>null</td>
</tr>
</tbody>
</table>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>Added support for int- and float-derived Enum classes.</p>
</div>
<p>To extend this to recognize other objects, subclass and implement a
<a class="reference internal" href="#json.JSONEncoder.default" title="json.JSONEncoder.default"><code class="xref py py-meth docutils literal"><span class="pre">default()</span></code></a> method with another method that returns a serializable object
for <code class="docutils literal"><span class="pre">o</span></code> if possible, otherwise it should call the superclass implementation
(to raise <a class="reference internal" href="exceptions.html#TypeError" title="TypeError"><code class="xref py py-exc docutils literal"><span class="pre">TypeError</span></code></a>).</p>
<p>If <em>skipkeys</em> is <code class="docutils literal"><span class="pre">False</span></code> (the default), then it is a <a class="reference internal" href="exceptions.html#TypeError" title="TypeError"><code class="xref py py-exc docutils literal"><span class="pre">TypeError</span></code></a> to
attempt encoding of keys that are not str, int, float or None.  If
<em>skipkeys</em> is <code class="docutils literal"><span class="pre">True</span></code>, such items are simply skipped.</p>
<p>If <em>ensure_ascii</em> is <code class="docutils literal"><span class="pre">True</span></code> (the default), the output is guaranteed to
have all incoming non-ASCII characters escaped.  If <em>ensure_ascii</em> is
<code class="docutils literal"><span class="pre">False</span></code>, these characters will be output as-is.</p>
<p>If <em>check_circular</em> is <code class="docutils literal"><span class="pre">True</span></code> (the default), then lists, dicts, and custom
encoded objects will be checked for circular references during encoding to
prevent an infinite recursion (which would cause an <a class="reference internal" href="exceptions.html#OverflowError" title="OverflowError"><code class="xref py py-exc docutils literal"><span class="pre">OverflowError</span></code></a>).
Otherwise, no such check takes place.</p>
<p>If <em>allow_nan</em> is <code class="docutils literal"><span class="pre">True</span></code> (the default), then <code class="docutils literal"><span class="pre">NaN</span></code>, <code class="docutils literal"><span class="pre">Infinity</span></code>, and
<code class="docutils literal"><span class="pre">-Infinity</span></code> will be encoded as such.  This behavior is not JSON
specification compliant, but is consistent with most JavaScript based
encoders and decoders.  Otherwise, it will be a <a class="reference internal" href="exceptions.html#ValueError" title="ValueError"><code class="xref py py-exc docutils literal"><span class="pre">ValueError</span></code></a> to encode
such floats.</p>
<p>If <em>sort_keys</em> is <code class="docutils literal"><span class="pre">True</span></code> (default <code class="docutils literal"><span class="pre">False</span></code>), then the output of dictionaries
will be sorted by key; this is useful for regression tests to ensure that
JSON serializations can be compared on a day-to-day basis.</p>
<p>If <em>indent</em> is a non-negative integer or string, then JSON array elements and
object members will be pretty-printed with that indent level.  An indent level
of 0, negative, or <code class="docutils literal"><span class="pre">&quot;&quot;</span></code> will only insert newlines.  <code class="docutils literal"><span class="pre">None</span></code> (the default)
selects the most compact representation. Using a positive integer indent
indents that many spaces per level.  If <em>indent</em> is a string (such as <code class="docutils literal"><span class="pre">&quot;\t&quot;</span></code>),
that string is used to indent each level.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.2: </span>Allow strings for <em>indent</em> in addition to integers.</p>
</div>
<p>If specified, <em>separators</em> should be an <code class="docutils literal"><span class="pre">(item_separator,</span> <span class="pre">key_separator)</span></code>
tuple.  The default is <code class="docutils literal"><span class="pre">(',</span> <span class="pre">',</span> <span class="pre">':</span> <span class="pre">')</span></code> if <em>indent</em> is <code class="docutils literal"><span class="pre">None</span></code> and
<code class="docutils literal"><span class="pre">(',',</span> <span class="pre">':</span> <span class="pre">')</span></code> otherwise.  To get the most compact JSON representation,
you should specify <code class="docutils literal"><span class="pre">(',',</span> <span class="pre">':')</span></code> to eliminate whitespace.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>Use <code class="docutils literal"><span class="pre">(',',</span> <span class="pre">':</span> <span class="pre">')</span></code> as default if <em>indent</em> is not <code class="docutils literal"><span class="pre">None</span></code>.</p>
</div>
<p>If specified, <em>default</em> is a function that gets called for objects that can&#8217;t
otherwise be serialized.  It should return a JSON encodable version of the
object or raise a <a class="reference internal" href="exceptions.html#TypeError" title="TypeError"><code class="xref py py-exc docutils literal"><span class="pre">TypeError</span></code></a>.</p>
<dl class="method">
<dt id="json.JSONEncoder.default">
<code class="descname">default</code><span class="sig-paren">(</span><em>o</em><span class="sig-paren">)</span><a class="headerlink" href="#json.JSONEncoder.default" title="Permalink to this definition">¶</a></dt>
<dd><p>Implement this method in a subclass such that it returns a serializable
object for <em>o</em>, or calls the base implementation (to raise a
<a class="reference internal" href="exceptions.html#TypeError" title="TypeError"><code class="xref py py-exc docutils literal"><span class="pre">TypeError</span></code></a>).</p>
<p>For example, to support arbitrary iterators, you could implement default
like this:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="k">def</span> <span class="nf">default</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">o</span><span class="p">):</span>
   <span class="k">try</span><span class="p">:</span>
       <span class="n">iterable</span> <span class="o">=</span> <span class="nb">iter</span><span class="p">(</span><span class="n">o</span><span class="p">)</span>
   <span class="k">except</span> <span class="ne">TypeError</span><span class="p">:</span>
       <span class="k">pass</span>
   <span class="k">else</span><span class="p">:</span>
       <span class="k">return</span> <span class="nb">list</span><span class="p">(</span><span class="n">iterable</span><span class="p">)</span>
   <span class="c"># Let the base class default method raise the TypeError</span>
   <span class="k">return</span> <span class="n">json</span><span class="o">.</span><span class="n">JSONEncoder</span><span class="o">.</span><span class="n">default</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">o</span><span class="p">)</span>
</pre></div>
</div>
</dd></dl>

<dl class="method">
<dt id="json.JSONEncoder.encode">
<code class="descname">encode</code><span class="sig-paren">(</span><em>o</em><span class="sig-paren">)</span><a class="headerlink" href="#json.JSONEncoder.encode" title="Permalink to this definition">¶</a></dt>
<dd><p>Return a JSON string representation of a Python data structure, <em>o</em>.  For
example:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">JSONEncoder</span><span class="p">()</span><span class="o">.</span><span class="n">encode</span><span class="p">({</span><span class="s">&quot;foo&quot;</span><span class="p">:</span> <span class="p">[</span><span class="s">&quot;bar&quot;</span><span class="p">,</span> <span class="s">&quot;baz&quot;</span><span class="p">]})</span>
<span class="go">&#39;{&quot;foo&quot;: [&quot;bar&quot;, &quot;baz&quot;]}&#39;</span>
</pre></div>
</div>
</dd></dl>

<dl class="method">
<dt id="json.JSONEncoder.iterencode">
<code class="descname">iterencode</code><span class="sig-paren">(</span><em>o</em><span class="sig-paren">)</span><a class="headerlink" href="#json.JSONEncoder.iterencode" title="Permalink to this definition">¶</a></dt>
<dd><p>Encode the given object, <em>o</em>, and yield each string representation as
available.  For example:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="k">for</span> <span class="n">chunk</span> <span class="ow">in</span> <span class="n">json</span><span class="o">.</span><span class="n">JSONEncoder</span><span class="p">()</span><span class="o">.</span><span class="n">iterencode</span><span class="p">(</span><span class="n">bigobject</span><span class="p">):</span>
    <span class="n">mysocket</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">chunk</span><span class="p">)</span>
</pre></div>
</div>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="exceptions">
<h2>19.2.3. Exceptions<a class="headerlink" href="#exceptions" title="Permalink to this headline">¶</a></h2>
<dl class="exception">
<dt id="json.JSONDecodeError">
<em class="property">exception </em><code class="descclassname">json.</code><code class="descname">JSONDecodeError</code><span class="sig-paren">(</span><em>msg</em>, <em>doc</em>, <em>pos</em>, <em>end=None</em><span class="sig-paren">)</span><a class="headerlink" href="#json.JSONDecodeError" title="Permalink to this definition">¶</a></dt>
<dd><blockquote>
<div><p>Subclass of <a class="reference internal" href="exceptions.html#ValueError" title="ValueError"><code class="xref py py-exc docutils literal"><span class="pre">ValueError</span></code></a> with the following additional attributes:</p>
<dl class="attribute">
<dt id="json.JSONDecodeError.msg">
<code class="descname">msg</code><a class="headerlink" href="#json.JSONDecodeError.msg" title="Permalink to this definition">¶</a></dt>
<dd><p>The unformatted error message.</p>
</dd></dl>

<dl class="attribute">
<dt id="json.JSONDecodeError.doc">
<code class="descname">doc</code><a class="headerlink" href="#json.JSONDecodeError.doc" title="Permalink to this definition">¶</a></dt>
<dd><p>The JSON document being parsed.</p>
</dd></dl>

<dl class="attribute">
<dt id="json.JSONDecodeError.pos">
<code class="descname">pos</code><a class="headerlink" href="#json.JSONDecodeError.pos" title="Permalink to this definition">¶</a></dt>
<dd><p>The start index of <em>doc</em> where parsing failed.</p>
</dd></dl>

<dl class="attribute">
<dt id="json.JSONDecodeError.lineno">
<code class="descname">lineno</code><a class="headerlink" href="#json.JSONDecodeError.lineno" title="Permalink to this definition">¶</a></dt>
<dd><p>The line corresponding to <em>pos</em>.</p>
</dd></dl>

<dl class="attribute">
<dt id="json.JSONDecodeError.colno">
<code class="descname">colno</code><a class="headerlink" href="#json.JSONDecodeError.colno" title="Permalink to this definition">¶</a></dt>
<dd><p>The column corresponding to <em>pos</em>.</p>
</dd></dl>

</div></blockquote>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

</div>
<div class="section" id="standard-compliance-and-interoperability">
<h2>19.2.4. Standard Compliance and Interoperability<a class="headerlink" href="#standard-compliance-and-interoperability" title="Permalink to this headline">¶</a></h2>
<p>The JSON format is specified by <span class="target" id="index-2"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7159.html"><strong>RFC 7159</strong></a> and by
<a class="reference external" href="http://www.ecma-international.org/publications/standards/Ecma-404.htm">ECMA-404</a>.
This section details this module&#8217;s level of compliance with the RFC.
For simplicity, <a class="reference internal" href="#json.JSONEncoder" title="json.JSONEncoder"><code class="xref py py-class docutils literal"><span class="pre">JSONEncoder</span></code></a> and <a class="reference internal" href="#json.JSONDecoder" title="json.JSONDecoder"><code class="xref py py-class docutils literal"><span class="pre">JSONDecoder</span></code></a> subclasses, and
parameters other than those explicitly mentioned, are not considered.</p>
<p>This module does not comply with the RFC in a strict fashion, implementing some
extensions that are valid JavaScript but not valid JSON.  In particular:</p>
<ul class="simple">
<li>Infinite and NaN number values are accepted and output;</li>
<li>Repeated names within an object are accepted, and only the value of the last
name-value pair is used.</li>
</ul>
<p>Since the RFC permits RFC-compliant parsers to accept input texts that are not
RFC-compliant, this module&#8217;s deserializer is technically RFC-compliant under
default settings.</p>
<div class="section" id="character-encodings">
<h3>19.2.4.1. Character Encodings<a class="headerlink" href="#character-encodings" title="Permalink to this headline">¶</a></h3>
<p>The RFC requires that JSON be represented using either UTF-8, UTF-16, or
UTF-32, with UTF-8 being the recommended default for maximum interoperability.</p>
<p>As permitted, though not required, by the RFC, this module&#8217;s serializer sets
<em>ensure_ascii=True</em> by default, thus escaping the output so that the resulting
strings only contain ASCII characters.</p>
<p>Other than the <em>ensure_ascii</em> parameter, this module is defined strictly in
terms of conversion between Python objects and
<a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">Unicode</span> <span class="pre">strings</span></code></a>, and thus does not otherwise directly address
the issue of character encodings.</p>
<p>The RFC prohibits adding a byte order mark (BOM) to the start of a JSON text,
and this module&#8217;s serializer does not add a BOM to its output.
The RFC permits, but does not require, JSON deserializers to ignore an initial
BOM in their input.  This module&#8217;s deserializer raises a <a class="reference internal" href="exceptions.html#ValueError" title="ValueError"><code class="xref py py-exc docutils literal"><span class="pre">ValueError</span></code></a>
when an initial BOM is present.</p>
<p>The RFC does not explicitly forbid JSON strings which contain byte sequences
that don&#8217;t correspond to valid Unicode characters (e.g. unpaired UTF-16
surrogates), but it does note that they may cause interoperability problems.
By default, this module accepts and outputs (when present in the original
<a class="reference internal" href="stdtypes.html#str" title="str"><code class="xref py py-class docutils literal"><span class="pre">str</span></code></a>) code points for such sequences.</p>
</div>
<div class="section" id="infinite-and-nan-number-values">
<h3>19.2.4.2. Infinite and NaN Number Values<a class="headerlink" href="#infinite-and-nan-number-values" title="Permalink to this headline">¶</a></h3>
<p>The RFC does not permit the representation of infinite or NaN number values.
Despite that, by default, this module accepts and outputs <code class="docutils literal"><span class="pre">Infinity</span></code>,
<code class="docutils literal"><span class="pre">-Infinity</span></code>, and <code class="docutils literal"><span class="pre">NaN</span></code> as if they were valid JSON number literal values:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="c"># Neither of these calls raises an exception, but the results are not valid JSON</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">(</span><span class="nb">float</span><span class="p">(</span><span class="s">&#39;-inf&#39;</span><span class="p">))</span>
<span class="go">&#39;-Infinity&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">dumps</span><span class="p">(</span><span class="nb">float</span><span class="p">(</span><span class="s">&#39;nan&#39;</span><span class="p">))</span>
<span class="go">&#39;NaN&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="c"># Same when deserializing</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="s">&#39;-Infinity&#39;</span><span class="p">)</span>
<span class="go">-inf</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="s">&#39;NaN&#39;</span><span class="p">)</span>
<span class="go">nan</span>
</pre></div>
</div>
<p>In the serializer, the <em>allow_nan</em> parameter can be used to alter this
behavior.  In the deserializer, the <em>parse_constant</em> parameter can be used to
alter this behavior.</p>
</div>
<div class="section" id="repeated-names-within-an-object">
<h3>19.2.4.3. Repeated Names Within an Object<a class="headerlink" href="#repeated-names-within-an-object" title="Permalink to this headline">¶</a></h3>
<p>The RFC specifies that the names within a JSON object should be unique, but
does not mandate how repeated names in JSON objects should be handled.  By
default, this module does not raise an exception; instead, it ignores all but
the last name-value pair for a given name:</p>
<div class="highlight-python3"><div class="highlight"><pre><span class="gp">&gt;&gt;&gt; </span><span class="n">weird_json</span> <span class="o">=</span> <span class="s">&#39;{&quot;x&quot;: 1, &quot;x&quot;: 2, &quot;x&quot;: 3}&#39;</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">weird_json</span><span class="p">)</span>
<span class="go">{&#39;x&#39;: 3}</span>
</pre></div>
</div>
<p>The <em>object_pairs_hook</em> parameter can be used to alter this behavior.</p>
</div>
<div class="section" id="top-level-non-object-non-array-values">
<h3>19.2.4.4. Top-level Non-Object, Non-Array Values<a class="headerlink" href="#top-level-non-object-non-array-values" title="Permalink to this headline">¶</a></h3>
<p>The old version of JSON specified by the obsolete <span class="target" id="index-3"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc4627.html"><strong>RFC 4627</strong></a> required that
the top-level value of a JSON text must be either a JSON object or array
(Python <a class="reference internal" href="stdtypes.html#dict" title="dict"><code class="xref py py-class docutils literal"><span class="pre">dict</span></code></a> or <a class="reference internal" href="stdtypes.html#list" title="list"><code class="xref py py-class docutils literal"><span class="pre">list</span></code></a>), and could not be a JSON null,
boolean, number, or string value.  <span class="target" id="index-4"></span><a class="rfc reference external" href="https://tools.ietf.org/html/rfc7159.html"><strong>RFC 7159</strong></a> removed that restriction, and
this module does not and has never implemented that restriction in either its
serializer or its deserializer.</p>
<p>Regardless, for maximum interoperability, you may wish to voluntarily adhere
to the restriction yourself.</p>
</div>
<div class="section" id="implementation-limitations">
<h3>19.2.4.5. Implementation Limitations<a class="headerlink" href="#implementation-limitations" title="Permalink to this headline">¶</a></h3>
<p>Some JSON deserializer implementations may set limits on:</p>
<ul class="simple">
<li>the size of accepted JSON texts</li>
<li>the maximum level of nesting of JSON objects and arrays</li>
<li>the range and precision of JSON numbers</li>
<li>the content and maximum length of JSON strings</li>
</ul>
<p>This module does not impose any such limits beyond those of the relevant
Python datatypes themselves or the Python interpreter itself.</p>
<p>When serializing to JSON, beware any such limitations in applications that may
consume your JSON.  In particular, it is common for JSON numbers to be
deserialized into IEEE 754 double precision numbers and thus subject to that
representation&#8217;s range and precision limitations.  This is especially relevant
when serializing Python <a class="reference internal" href="functions.html#int" title="int"><code class="xref py py-class docutils literal"><span class="pre">int</span></code></a> values of extremely large magnitude, or
when serializing instances of &#8220;exotic&#8221; numerical types such as
<a class="reference internal" href="decimal.html#decimal.Decimal" title="decimal.Decimal"><code class="xref py py-class docutils literal"><span class="pre">decimal.Decimal</span></code></a>.</p>
<span class="target" id="module-json.tool"></span></div>
</div>
<div class="section" id="command-line-interface">
<span id="json-commandline"></span><h2>19.2.5. Command Line Interface<a class="headerlink" href="#command-line-interface" title="Permalink to this headline">¶</a></h2>
<p>The <a class="reference internal" href="#module-json.tool" title="json.tool"><code class="xref py py-mod docutils literal"><span class="pre">json.tool</span></code></a> module provides a simple command line interface to validate
and pretty-print JSON objects.</p>
<p>If the optional <code class="docutils literal"><span class="pre">infile</span></code> and <code class="docutils literal"><span class="pre">outfile</span></code> arguments are not
specified, <a class="reference internal" href="sys.html#sys.stdin" title="sys.stdin"><code class="xref py py-attr docutils literal"><span class="pre">sys.stdin</span></code></a> and <a class="reference internal" href="sys.html#sys.stdout" title="sys.stdout"><code class="xref py py-attr docutils literal"><span class="pre">sys.stdout</span></code></a> will be used respectively:</p>
<div class="highlight-bash"><div class="highlight"><pre><span class="nv">$ </span><span class="nb">echo</span> <span class="s1">&#39;{&quot;json&quot;: &quot;obj&quot;}&#39;</span> <span class="p">|</span> python -m json.tool
<span class="o">{</span>
    <span class="s2">&quot;json&quot;</span>: <span class="s2">&quot;obj&quot;</span>
<span class="o">}</span>
<span class="nv">$ </span><span class="nb">echo</span> <span class="s1">&#39;{1.2:3.4}&#39;</span> <span class="p">|</span> python -m json.tool
Expecting property name enclosed in double quotes: line <span class="m">1</span> column <span class="m">2</span> <span class="o">(</span>char 1<span class="o">)</span>
</pre></div>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>The output is now in the same order as the input. Use the
<a class="reference internal" href="#cmdoption--sort-keys"><code class="xref std std-option docutils literal"><span class="pre">--sort-keys</span></code></a> option to sort the output of dictionaries
alphabetically by key.</p>
</div>
<div class="section" id="command-line-options">
<h3>19.2.5.1. Command line options<a class="headerlink" href="#command-line-options" title="Permalink to this headline">¶</a></h3>
<dl class="cmdoption">
<dt id="cmdoption-arg-infile">
<code class="descname">infile</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-arg-infile" title="Permalink to this definition">¶</a></dt>
<dd><p>The JSON file to be validated or pretty-printed:</p>
<div class="highlight-bash"><div class="highlight"><pre><span class="nv">$ </span>python -m json.tool mp_films.json
<span class="o">[</span>
    <span class="o">{</span>
        <span class="s2">&quot;title&quot;</span>: <span class="s2">&quot;And Now for Something Completely Different&quot;</span>,
        <span class="s2">&quot;year&quot;</span>: 1971
    <span class="o">}</span>,
    <span class="o">{</span>
        <span class="s2">&quot;title&quot;</span>: <span class="s2">&quot;Monty Python and the Holy Grail&quot;</span>,
        <span class="s2">&quot;year&quot;</span>: 1975
    <span class="o">}</span>
<span class="o">]</span>
</pre></div>
</div>
<p>If <em>infile</em> is not specified, read from <a class="reference internal" href="sys.html#sys.stdin" title="sys.stdin"><code class="xref py py-attr docutils literal"><span class="pre">sys.stdin</span></code></a>.</p>
</dd></dl>

<dl class="cmdoption">
<dt id="cmdoption-arg-outfile">
<code class="descname">outfile</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-arg-outfile" title="Permalink to this definition">¶</a></dt>
<dd><p>Write the output of the <em>infile</em> to the given <em>outfile</em>. Otherwise, write it
to <a class="reference internal" href="sys.html#sys.stdout" title="sys.stdout"><code class="xref py py-attr docutils literal"><span class="pre">sys.stdout</span></code></a>.</p>
</dd></dl>

<dl class="cmdoption">
<dt id="cmdoption--sort-keys">
<code class="descname">--sort-keys</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption--sort-keys" title="Permalink to this definition">¶</a></dt>
<dd><p>Sort the output of dictionaries alphabetically by key.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
</dd></dl>

<dl class="cmdoption">
<dt id="cmdoption-h">
<span id="cmdoption--help"></span><code class="descname">-h</code><code class="descclassname"></code><code class="descclassname">, </code><code class="descname">--help</code><code class="descclassname"></code><a class="headerlink" href="#cmdoption-h" title="Permalink to this definition">¶</a></dt>
<dd><p>Show the help message.</p>
</dd></dl>

<p class="rubric">Footnotes</p>
<table class="docutils footnote" frame="void" id="rfc-errata" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id1">[1]</a></td><td>As noted in <a class="reference external" href="http://www.rfc-editor.org/errata_search.php?rfc=7159">the errata for RFC 7159</a>,
JSON permits literal U+2028 (LINE SEPARATOR) and
U+2029 (PARAGRAPH SEPARATOR) characters in strings, whereas JavaScript
(as of ECMAScript Edition 5.1) does not.</td></tr>
</tbody>
</table>
</div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">19.2. <code class="docutils literal"><span class="pre">json</span></code> &#8212; JSON encoder and decoder</a><ul>
<li><a class="reference internal" href="#basic-usage">19.2.1. Basic Usage</a></li>
<li><a class="reference internal" href="#encoders-and-decoders">19.2.2. Encoders and Decoders</a></li>
<li><a class="reference internal" href="#exceptions">19.2.3. Exceptions</a></li>
<li><a class="reference internal" href="#standard-compliance-and-interoperability">19.2.4. Standard Compliance and Interoperability</a><ul>
<li><a class="reference internal" href="#character-encodings">19.2.4.1. Character Encodings</a></li>
<li><a class="reference internal" href="#infinite-and-nan-number-values">19.2.4.2. Infinite and NaN Number Values</a></li>
<li><a class="reference internal" href="#repeated-names-within-an-object">19.2.4.3. Repeated Names Within an Object</a></li>
<li><a class="reference internal" href="#top-level-non-object-non-array-values">19.2.4.4. Top-level Non-Object, Non-Array Values</a></li>
<li><a class="reference internal" href="#implementation-limitations">19.2.4.5. Implementation Limitations</a></li>
</ul>
</li>
<li><a class="reference internal" href="#command-line-interface">19.2.5. Command Line Interface</a><ul>
<li><a class="reference internal" href="#command-line-options">19.2.5.1. Command line options</a></li>
</ul>
</li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="email-examples.html"
                        title="previous chapter">19.1.14. <code class="docutils literal"><span class="pre">email</span></code>: Examples</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="mailcap.html"
                        title="next chapter">19.3. <code class="docutils literal"><span class="pre">mailcap</span></code> &#8212; Mailcap file handling</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/json.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="mailcap.html" title="19.3. mailcap — Mailcap file handling"
             >next</a> |</li>
        <li class="right" >
          <a href="email-examples.html" title="19.1.14. email: Examples"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="netdata.html" >19. Internet Data Handling</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>